%% SLOC canonical paths, Cell 1: CP from p3/pt19 to f1/pt13; nat.continuation
p=[]; p=ocinit(p,'p3','pt19','f1','pt13'); % set standard options, also set
% p3/pt19 as start and f1/pt13 as end point of the canonical path
p.oc.rhoi=1; % index of discount rate rho, rho is at p.u(p.nu+p.nq+rhoi)
p.oc.T=100; % truncation time
% reset some oc-params to customized values 
p.oc.nti=41; % initial # of points in t-mesh 
p.oc.msw=1; % use secant predictors (after first step) in isc
alvin=[0.25 0.5 0.75 1]; % desired alpha-values; these can also be split, 
% e.g., first call isc with alvin=[0.25 0.5], then again with alvin=[0.75 1]  
p=isc(p,alvin); va=[15,30]; slsolplot(p,va); % continuation call and plot 
%% Cell 2: start with small T, then set T free (test T adaptation) 
p=[]; p=ocinit(p,'p3','pt19','f1','pt13'); p.oc.rhoi=1; p.oc.T=20; 
p.oc.nti=41; p.oc.msw=1; p.oc.tadevs=1e-2; p.oc.verb=2; 
alvin=[0.25 0.5 0.75 1]; p=isc(p,alvin); 
va=[15,30]; slsolplot(p,va); tadev(p); % some plots 
%% Cell2b: decrease ||u(1)-\uhat|| (increasing T from 43 to about 50) 
p2=p; p2.oc.tadevs=1e-4; p2=isc(p2,1); slsolplot(p2,va); tadev(p2); 
%% Cell 3: a fold in alpha, arclength contiuation is needed, initial call
p=[]; p=ocinit(p,'p1','pt68','f1','pt13');
p.oc.rhoi=1; p.oc.nti=41; p.oc.T=100;
p.oc.sig=0.1;  p.oc.sigmax=1; % stepsize and max stepsize 
p.tomopt.Stats_step='on'; % give mtom diagnostics 
p.oc.retsw=1; % return full alpha and soln history 
alvin=[0.2 0.3]; p=isc(p,alvin,3); % continuation call, startup 
%% Cell 4: subsequent arclength-continuation-calls (repeat this cell to continue further) 
p=isc(p,[],30);  % For Skibademo Cell 3,4 have to be run to have p in workspace, or save p
% here and load in Skibademo
% save('skibap.mat','p');
%% Cell 4b, plots, including a simple plot of J over alpha, 
figure(6); clf; va=[25,15]; slsolplotT(p,va); 
plot(p.hist.alpha(1,:),p.hist.vv(1,:),'-*'); 
xlabel('\alpha'); ylabel('J_{a}'); set(gca,'FontSize',14); 
%% Cell 5: fix al from arc cont to some given value and compute CP
% The al value closest to the desired is picked from p.hist.alpha
p.cp.u=p.hist.u{end-2}; p.cp.t=p.hist.tt{end-2};
p.cp.par=p.hist.par{end-2}; % extract sol from history
p=isc(p,0.6); v=[100,30]; slsolplot(p,va); % compute at desired al value and plot 